
public class SalesIQManageAssignmentCtrl {
    
    public static List<String> MANDATORY_POSITION_ASSIGN_DETAILS_FIELDS = new List<String>{'Assignment_Type__c', 'Effective_End_Date__c', 'Effective_Start_Date__c', 'Employee__c',
                                                        'Name','Change_Status__c', 'Employee__r.Name', 'Employee__r.Employee_Type__c', 'Position__c', 'Position__r.Name', 'Position__r.Effective_Start_Date__c', 
                                                        'Position__r.Effective_End_Date__c','Position__r.Parent_Position__r.Name', 'Position__r.Position_Type__c', 'Position__r.Team_Instance__c', 
                                                        'Position__r.Team_Instance__r.IC_EffstartDate__c', 'Position__r.Team_Instance__r.IC_EffEndDate__c', 'Employee__r.Original_Hire_Date__c', 
                                                        'Employee__r.HR_Termination_Date__c','Last_Approved_Assignment_Type__c','Last_Approved_End_Date__c','Last_Approved_Start_Date__c','Reason_Code__c','Employee__r.Rehire_Date__c','Position__r.Client_Position_Code__c'};
    
    public static final List<String> CHANGE_REQUEST_INSERT_FIELD = new List<String>{'Status__c','RecordTypeID__c','Execution_Date__c','Source_Position__c','Parent_Change_Request_ID__c', 
                                            'Account_Moved_Id__c', 'Change_String_Value__c', 'Request_Type_Change__c', 'Destination_Position__c', 'Reason__c', 'Team_Instance_ID__c', 
                                            'Source_Positions__c', 'Destination_Positions__c', 'RecordtypeId'};
    
    public static final List<String> EMPLOYEE_UPDATE_FIELD = new List<String>{'Change_Status__c'};

    public static final String namespace = SalesIQGlobalConstants.Name_space;


    @AuraEnabled
    public static List<String> getLocaleDateFormats() {
        return new List<String>{SalesIQUtility.getUserDateFormat(), SalesIQUtility.getUserDateTimeFormat()};
    }

    @AuraEnabled
    public static String getOrgNamespace() 
    {
        return SalesIQGlobalConstants.NAME_SPACE;        
    }

    @AuraEnabled
    public static List<ObjectDetailWrapper> getAssignments(String recordId,String moduleName)
    {
        List<Team_Instance_Object_Attribute__c> assignmentPopupFields = SalesIQUtility.getTeamInstanceAttrFromInterfaceName(moduleName == SalesIQGlobalConstants.EMPLOYEE_UNIVERSE ? SalesIQGlobalConstants.MANAGE_ASSIGNMENT_EDIT_EMPLOYEE_POPUP : SalesIQGlobalConstants.MANAGE_ASSIGNMENT_EDIT_POSITION_POPUP);

        List<ObjectDetailWrapper> recordDetailWrapperList = new List<ObjectDetailWrapper>();
        String soql = 'SELECT  ' + getSOQL(MANDATORY_POSITION_ASSIGN_DETAILS_FIELDS, assignmentPopupFields) + ' FROM Position_Employee__c ';
        
        if(moduleName == SalesIQGlobalConstants.POSITION_UNIVERSE)
            soql += 'where Position__c =: recordId and Employee__c != null' ; 
        else if(moduleName == SalesIQGlobalConstants.EMPLOYEE_UNIVERSE)
            soql += 'where Employee__c =: recordId and Position__c != null' ;            

        List<Position_Employee__c> posEmpList = Database.query(soql);
        
        for(Position_Employee__c pE : posEmpList) {
            ObjectDetailWrapper recordDetailWrapper = new ObjectDetailWrapper();
            recordDetailWrapper.record = pE;
            recordDetailWrapper.isNew = false ;
            recordDetailWrapper.name = moduleName == SalesIQGlobalConstants.EMPLOYEE_UNIVERSE ? pE.Position__r.Name : pE.Employee__r.Name ;
            recordDetailWrapper.type = moduleName == SalesIQGlobalConstants.EMPLOYEE_UNIVERSE ? pE.Position__r.Position_Type__c : pE.Employee__r.Employee_Type__c ;
            recordDetailWrapper.clientPositionCode = pE.Position__r.Client_Position_Code__c; 
            recordDetailWrapper.recordDetails = getAssignmentDetails(recordDetailWrapper.record, assignmentPopupFields);
            recordDetailWrapperList.add(recordDetailWrapper);
        }

        return recordDetailWrapperList ;
    }

    @AuraEnabled
    public static List<ObjectDetailWrapper> addAssignments(List<String> selectedIds, String recordId,String moduleName, String defaultAssignmentType)
    {
        List<ObjectDetailWrapper> recordDetailWrapperList = new List<ObjectDetailWrapper>();
        List<Team_Instance_Object_Attribute__c> assignmentPopupFields = SalesIQUtility.getTeamInstanceAttrFromInterfaceName(moduleName == SalesIQGlobalConstants.EMPLOYEE_UNIVERSE ? SalesIQGlobalConstants.MANAGE_ASSIGNMENT_EDIT_EMPLOYEE_POPUP : SalesIQGlobalConstants.MANAGE_ASSIGNMENT_EDIT_POSITION_POPUP);

   
        if(String.isblank(defaultAssignmentType)){
            defaultAssignmentType='Primary';
        }
        if(moduleName == SalesIQGlobalConstants.EMPLOYEE_UNIVERSE)
        {
            Set<Id> objectIds = new Set<Id>();
            for(String recId : selectedIds) {
                objectIds.add((Id) recId);
            }  
            // adito: @todo: Add dynmaic field to Salesiq utility class
            List<Position__c> positionList = SalesIQUtility.getPositionById(objectIds);
            List<Employee__c> employeeDetail = SalesIQUtility.getEmployeesById(new Set<String>{recordId});
            Employee__c selectedEmployee = employeeDetail[0];

            for(Position__c position : positionList) {
                ObjectDetailWrapper recordDetailWrapper = new ObjectDetailWrapper();
                Position_Employee__c newEmployeeAssignment = new Position_Employee__c(Employee__c = recordId, Position__c = position.Id, Position__r = position, Effective_Start_Date__c = ruleStartDate() > position.Effective_Start_Date__c ? ruleStartDate() : position.Effective_Start_Date__c, Effective_End_Date__c = position.Effective_End_Date__c, Assignment_Type__c = defaultAssignmentType, Reason_Code__c = null,Employee__r = selectedEmployee);
                
                recordDetailWrapper.record = newEmployeeAssignment ;
                recordDetailWrapper.isNew = true ;
                recordDetailWrapper.manageVacant = position.Manage_Vacant__c;
                recordDetailWrapper.name = position.Name ;
                recordDetailWrapper.type = position.Position_Type__c ;
                recordDetailWrapper.clientPositionCode = position.Client_Position_Code__c;
                
                recordDetailWrapper.recordDetails = getAssignmentDetails(recordDetailWrapper.record, assignmentPopupFields);
                recordDetailWrapperList.add(recordDetailWrapper);
            }
        }
        else if(moduleName == SalesIQGlobalConstants.POSITION_UNIVERSE)
        {
            // adito: @todo: Add dynmaic field to Salesiq utility class
            List<Employee__c> employeeList = SalesIQUtility.getEmployeesById(new Set<String>(selectedIds));
            Position__c position = SalesIQUtility.getPositionById(new Set<Id>{recordId})[0];

            for(Employee__c employee : employeeList) {
                ObjectDetailWrapper recordDetailWrapper = new ObjectDetailWrapper();
                Position_Employee__c newEmployeeAssignment = new Position_Employee__c(Employee__c = employee.Id, Position__c = recordId, Position__r = position, Effective_Start_Date__c = ruleStartDate() > position.Effective_Start_Date__c ? ruleStartDate() : position.Effective_Start_Date__c, Effective_End_Date__c = position.Effective_End_Date__c,Assignment_Type__c = defaultAssignmentType, Reason_Code__c = null,Employee__r = employee);
                
                recordDetailWrapper.record = newEmployeeAssignment ;
                recordDetailWrapper.isNew = true ;
                recordDetailWrapper.name = employee.Name ;
                recordDetailWrapper.type = employee.Employee_Type__c ;
                recordDetailWrapper.recordDetails = getAssignmentDetails(recordDetailWrapper.record, assignmentPopupFields);
                recordDetailWrapperList.add(recordDetailWrapper);
            }
        }



        return recordDetailWrapperList ;
    }

    private static Date ruleStartDate(){
        Position_Global_Settings__c global_15_16_ruleSetting = Position_Global_Settings__c.getInstance('default_15_16_Rule'); //added by gurpreet for 15/16 rule
        Date startDate = System.today();
        Date finalStartDate=null;
        if(global_15_16_ruleSetting!= null && global_15_16_ruleSetting.Child_Effective_Dates_within_Parent__c){
            if(startDate.day() < 16){
                    finalStartDate = date.newInstance(startDate.year(), startDate.month(), 1);
                }
                else{
                    finalStartDate = date.newInstance(startDate.year(), startDate.month()+1, 1);
            }
            
                return finalStartDate;
        }
        else{
            return startDate;
        }
    }


    private static String getSOQL(List<String> mandatoryFields, List<Team_Instance_Object_Attribute__c> assignmentPopupFields) {
        Set<String> queryFields = new Set<String>();
        
        for(Team_Instance_Object_Attribute__c attribite : assignmentPopupFields) {
            String fieldNameWithoutNS = attribite.Attribute_API_Name__c.trim().toLowerCase();
            fieldNameWithoutNS = fieldNameWithoutNS.replaceAll('(?i)' + namespace, '');
            queryFields.add(fieldNameWithoutNS.toLowerCase());
        }

        if(mandatoryFields != null && !mandatoryFields.isEmpty())
        {
            for(String fieldName : mandatoryFields) 
                queryFields.add(fieldName.trim().toLowerCase());
        }

        return String.join(new List<String>(queryFields), ',') ;
    }

    private static List<ObjectDetailWrapper.FieldDetailWrapper> getAssignmentDetails(SObject instance, List<Team_Instance_Object_Attribute__c> assignmentPopupFields)
    {
     
        Map<String, Schema.SObjectType> globalSchemaMap = Schema.getGlobalDescribe() ;
        Map<String, Map<String, Schema.SObjectField>> objectFieldMap = new Map<String, Map<String, Schema.SObjectField>>();
        List<ObjectDetailWrapper.FieldDetailWrapper> fieldsDetailWrapperList = new List<ObjectDetailWrapper.FieldDetailWrapper>();

        for(Team_Instance_Object_Attribute__c attribute : assignmentPopupFields) {
            ObjectDetailWrapper.FieldDetailWrapper fieldDetails = new ObjectDetailWrapper.FieldDetailWrapper();
            
            fieldDetails.fieldLabel = attribute.Attribute_Display_Name__c ;
            fieldDetails.fieldDataType = attribute.Data_Type__c ;
            fieldDetails.fieldApiName = attribute.Attribute_API_Name__c ;
            fieldDetails.isEditable = attribute.IsEditable__c ;
            fieldDetails.isRequired = attribute.IsRequired__c ;
            fieldDetails.date15Or16Rule = attribute.WrapperFieldMap__c;

            Object dataValue ;
            SObject intermediateObject = instance ;
            if(attribute.Attribute_API_Name__c.indexOf('.') != -1) {
                List<String> allfields = attribute.Attribute_API_Name__c.split('\\.');
                System.debug('allfields : '+allfields);
                //temp
                if(attribute.Data_Type__c == 'Reference' || attribute.Data_Type__c == 'Dependent'){
                    String fieldName = attribute.Attribute_API_Name__c.split('\\.')[1];
                    String objectName = attribute.Lookup_Object__c;

                    if(attribute.Data_Type__c == 'Reference'){
                        fieldDetails.fieldApiName = attribute.Attribute_API_Name__c.split('\\.')[0].replace('__r','__c') ;
                    }

                    list<sObject> objist = Database.query('select id,' +fieldName + ' from '+objectName);
                    map<String,String> referenceMap = new map<String,String>();
                    List<ObjectDetailWrapper.LookupDataWrapper> lookupValuesList = new List<ObjectDetailWrapper.LookupDataWrapper>();
                    for(sObject obj : objist){
                        referenceMap.put(obj.id,(String)obj.get(fieldName));
                        ObjectDetailWrapper.LookupDataWrapper lookupValues = new ObjectDetailWrapper.LookupDataWrapper();
                        lookupValues.objName = objectName;
                        lookupValues.text = (String)obj.get(fieldName);
                        lookupValues.val = (String)obj.id;
                        lookupValuesList.add(lookupValues);
                    }
                    System.debug('referenceMap : '+referenceMap);
                    
                    
                    fieldDetails.lookupDataList = lookupValuesList;
                }
                //temp end

                //for text type
                /*if(attribute.Data_Type__c == 'Text'){
                    String fieldName = attribute.Attribute_API_Name__c.split('\\.')[1];
                    String objectName = attribute.Lookup_Object__c;
                    System.debug('objectName : '+objectName+' fieldName : '+fieldName);
                    list<sObject> objist = Database.query('select id,' +fieldName + ' from '+objectName);
                    map<String,String> myReferenceMap1 = new map<String,String>();
                    for(sObject obj : objist){
                        myReferenceMap1.put(obj.id,(String)obj.get(fieldName));
                    }
                    System.debug('myReferenceMap1 : '+myReferenceMap1);
                    
                    
                    fieldDetails.referenceMap = myReferenceMap1.clone();
                }*/
                //end
                for(Integer i=0; i<allfields.size()-1; i++) {
                    String fieldName = allfields[i];
                    intermediateObject = intermediateObject.getSobject(fieldName);

                    if(intermediateObject == null) break ;
                }

                if(intermediateObject != null && attribute.Data_Type__c != 'Reference' ){
                    dataValue = intermediateObject.get(allfields[allfields.size()-1]);
                    System.debug('dataValue : '+dataValue);
                }
                else if(intermediateObject != null && attribute.Data_Type__c == 'Reference'){
                    dataValue = intermediateObject.get('id');
                }

            } else {
                // field is direct field of sobject
                dataValue = instance.get(fieldDetails.fieldApiName);
            }

            if(dataValue !=  null)
                if(attribute.IsEditable__c)
                    fieldDetails.fieldValue = getValueFromObject(attribute.Data_Type__c, dataValue,false);
                else 
                    fieldDetails.fieldValue = getValueFromObject(attribute.Data_Type__c, dataValue,true);

            // if datatype is picklist, get the values dynamically
                //attribute.IsEditable__c && attribute.Data_Type__c != null && 
            if(attribute.Data_Type__c.equalsIgnoreCase(Schema.DisplayType.PICKLIST.name())) {

                Schema.SObjectType targetType = globalSchemaMap.get(attribute.Object_Name__c);
                Schema.DescribeSObjectResult sobjectDescribe = targetType.getDescribe(); 
                
                Map<String, Schema.SObjectField> fieldMap ;
                if(objectFieldMap.containsKey(attribute.Object_Name__c)) {
                    fieldMap = objectFieldMap.get(attribute.Object_Name__c);
                } else {
                    fieldMap = sobjectDescribe.fields.getMap();
                }

                fieldDetails.setOfAvailableValues = new List<String>{''};
                fieldDetails.setOfAvailableValues.addAll(SalesIQUtility.getPicklistValuesFromFieldDescribe(fieldMap.get(attribute.Attribute_API_Name__c).getDescribe())) ;
            }
            
        
            fieldsDetailWrapperList.add(fieldDetails);
        }

        return fieldsDetailWrapperList ;
    }

    private static String getValueFromObject(String fieldDataType, Object dataValue, Boolean formatDate) {
        String fieldValue ;

        if(dataValue == null) return null;

        if(fieldDataType != null)
        {
            if(fieldDataType.equalsIgnoreCase(Schema.DisplayType.DATE.name()))
                if(formatDate)
                    fieldValue = String.valueOf(Date.valueOf(dataValue).format());
                else
                    fieldValue = String.valueOf(Date.valueOf(dataValue));
            
            else if(fieldDataType.equalsIgnoreCase(Schema.DisplayType.BOOLEAN.name()))
                fieldValue = String.valueOf(Boolean.valueOf(dataValue));
            
            else if(fieldDataType.equalsIgnoreCase(Schema.DisplayType.DATETIME.name()))
                if(formatDate)
                    fieldValue = String.valueOf(Datetime.valueOf(dataValue).format());
                else
                    fieldValue = String.valueOf(Datetime.valueOf(dataValue));
            
            else if(fieldDataType.equalsIgnoreCase(Schema.DisplayType.INTEGER.name()))
                fieldValue = String.valueOf(Integer.valueOf(dataValue));
            
            else if(fieldDataType.equalsIgnoreCase(Schema.DisplayType.DOUBLE.name()))
                fieldValue = String.valueOf(Double.valueOf(dataValue));
            else
                fieldValue = String.valueOf(dataValue);
        } else {
            // assume it to be text in case of data type missing
            fieldValue = String.valueOf(dataValue);
        }

        return fieldValue ;
    }

    /*private static SObject setValueToObject(String fieldDataType, String fieldApiName, String fieldValue, SObject record) {
        if(fieldDataType == Schema.DisplayType.DATE.name())
            record.put(fieldApiName, Date.valueOf(fieldValue));

        else if(fieldDataType == Schema.DisplayType.DATETIME.name())
            record.put(fieldApiName, DateTime.valueOf(fieldValue));
       
        else if(fieldDataType == Schema.DisplayType.BOOLEAN.name())
            record.put(fieldApiName, Boolean.valueOf(fieldValue));

        else if(fieldDataType == Schema.DisplayType.INTEGER.name())
            record.put(fieldApiName, Integer.valueOf(fieldValue));

        else if(fieldDataType == Schema.DisplayType.DOUBLE.name())
            record.put(fieldApiName, Double.valueOf(fieldValue));

        else
            record.put(fieldApiName, fieldValue);
        
        return record ;
    }*/

    private static ObjectDetailWrapper.FieldDetailWrapper addValidationMessage(ObjectDetailWrapper.FieldDetailWrapper fieldRecord, String errorMessage) {
        fieldRecord.isValidationFailed = true ;
        if(fieldRecord.validationErrorMessage == null)
            fieldRecord.validationErrorMessage = new Set<String>{errorMessage};
        else
            fieldRecord.validationErrorMessage.add(errorMessage);
        
        return fieldRecord;
    }

    private static Boolean checkValueChange(List<ObjectDetailWrapper> recordDetails){
        Boolean valueChangeFlag = false;
        // Loop to identify any change in the data 
        
        Set<Id> positionEmployeeIds = new Set<Id>();
        Set<String> fieldsToQuery = new Set<String>();
        for(ObjectDetailWrapper wr : recordDetails) 
        {   
            // If new assignment found, exit from loop
            if(wr.record.Id == null){
                valueChangeFlag = true ;
                break ;
            }
            else {
                positionEmployeeIds.add(wr.record.Id);
            }

            for(ObjectDetailWrapper.FieldDetailWrapper fieldRecord : wr.recordDetails) {
                if(fieldRecord.isEditable) {
                    fieldsToQuery.add(fieldRecord.fieldApiName.toLowerCase());
                }
            }
        }

        if(!valueChangeFlag) {
            if(SecurityUtil.checkRead(Position_Employee__c.SObjectType, new List<String>(fieldsToQuery), false)) {
                Map<Id, Position_Employee__c> actualEmployeeAssignments = new Map<Id, Position_Employee__c>((List<Position_Employee__c>) Database.query('Select ' + String.join(new List<String>(fieldsToQuery), ',') + ' from Position_Employee__c where id in:positionEmployeeIds'));
                for(ObjectDetailWrapper wr : recordDetails) {
                    for(ObjectDetailWrapper.FieldDetailWrapper fieldRecord : wr.recordDetails) {
                        // validation check for no value changes
                        if(fieldRecord.isEditable)
                        {
                            // if any value change found, exit from loop
                            Object oldfieldValue = actualEmployeeAssignments.get(wr.record.Id).get(fieldRecord.fieldApiName);
                            if(wr.record.get(fieldRecord.fieldApiName) != oldfieldValue) {
                                valueChangeFlag = true ;
                                break;
                            }
                        }
                    }
                }
            }
        }

        return valueChangeFlag ;
    }

    private static List<String> checkNullAndOverlappingValidation(List<ObjectDetailWrapper> recordDetails, String moduleName){
        /* NOTE: This method will change the recordDetails wrapper as it is passed by reference and return the error messages list*/
        Set<String> errorMessagesList = new Set<String>();
        Map<Date, ObjectDetailWrapper> allPrimaryAssignmentsByStartDate = new Map<Date, ObjectDetailWrapper>();

        for(ObjectDetailWrapper wr : recordDetails) {
                System.debug('wr :'+wr.recordDetails);
                Employee__c empObj = [select id,Original_Hire_Date__c, Rehire_Date__c,HR_Termination_Date__c from Employee__c where id =: wr.record.Employee__c];
                System.debug('empObj :'+empObj);
                Date checkStartDate, checkEndDate;
                String assignmentType;
                ObjectDetailWrapper.FieldDetailWrapper startDateFieldWrapper, endDateFieldWrapper, assignmentTypeFieldWrapper ;
                if(moduleName == SalesIQGlobalConstants.EMPLOYEE_UNIVERSE && wr.manageVacant==True){
                    String errorMessage = System.Label.Manage_Vacant_Position_Assignment;
                    wr.isRowValidationFailed = true ;
                    errorMessagesList.add(errorMessage);
                }
                for(ObjectDetailWrapper.FieldDetailWrapper fieldRecord : wr.recordDetails){

                    System.debug('fieldRecord :'+fieldRecord);
                    Position_Employee__c currentPositionEmployee = (Position_Employee__c)wr.record.clone(true, true) ;
                    
                    if(fieldRecord.isEditable || fieldRecord.fieldApiName == namespace+'Assignment_Type__c'){
                        if(fieldRecord.isRequired){
                            if(fieldRecord.fieldValue == null || fieldRecord.fieldValue == ''){
                                String errorMessage = string.format(System.Label.PositionFieldBlankPrompt,new list<string>{fieldRecord.fieldLabel}) ;
                                errorMessagesList.add(errorMessage);

                                fieldRecord = addValidationMessage(fieldRecord, errorMessage) ;
                                wr.isRowValidationFailed = true ;
                            }
                        }

                        // keep the assignment type
                        if(fieldRecord.fieldApiName == namespace+'Assignment_Type__c' && fieldRecord.fieldValue != '' && fieldRecord.fieldValue != null){
                            assignmentType = String.valueOf(fieldRecord.fieldValue);
                            assignmentTypeFieldWrapper =  fieldRecord ;
                        }

                        // checking date validation
                        if(fieldRecord.fieldDataType == Schema.DisplayType.DATE.name()) {
                            // excceding time range error
                            String instanceRangeExceedErrorMessage = string.format(System.Label.Position_Employee_dates_exceeded,new list<string>{currentPositionEmployee.Position__r.Team_Instance__r.IC_EffstartDate__c.format(), currentPositionEmployee.Position__r.Team_Instance__r.IC_EffEndDate__c.format()}) ;
                            String positionRangeExceedError = string.format(System.Label.EmployeeAssignmentDateBetweenPosition, new list<string>{currentPositionEmployee.Position__r.Effective_start_Date__c.format(), currentPositionEmployee.Position__r.Effective_end_Date__c.format()});

                            if(fieldRecord.fieldApiName == namespace+'Effective_Start_Date__c' && fieldRecord.fieldValue != '' && fieldRecord.fieldValue != null){
                                checkStartDate = Date.valueOf(fieldRecord.fieldValue);
                                startDateFieldWrapper = fieldRecord ;
                            
                               /* if(checkStartDate < currentPositionEmployee.Position__r.Team_Instance__r.IC_EffstartDate__c) {
                                    errorMessagesList.add(instanceRangeExceedErrorMessage);
                                    fieldRecord = addValidationMessage(fieldRecord, instanceRangeExceedErrorMessage) ;
                                    wr.isRowValidationFailed = true ;
                                }*/

                                if(checkStartDate < currentPositionEmployee.Position__r.Effective_Start_Date__c) {
                                    errorMessagesList.add(positionRangeExceedError);
                                    fieldRecord = addValidationMessage(fieldRecord, positionRangeExceedError) ;
                                    wr.isRowValidationFailed = true ;
                                }
                            }

                            if(fieldRecord.fieldApiName == namespace+'Effective_End_Date__c' && fieldRecord.fieldValue != '' && fieldRecord.fieldValue != null){
                                checkEndDate = Date.valueOf(fieldRecord.fieldValue);
                                endDateFieldWrapper = fieldRecord ;

                               /* if(checkEndDate > currentPositionEmployee.Position__r.Team_Instance__r.IC_EffEndDate__c) {
                                    errorMessagesList.add(instanceRangeExceedErrorMessage);
                                    fieldRecord = addValidationMessage(fieldRecord, instanceRangeExceedErrorMessage) ;
                                    wr.isRowValidationFailed = true ;
                                }*/

                                if(checkEndDate > currentPositionEmployee.Position__r.Effective_End_Date__c) {
                                    errorMessagesList.add(positionRangeExceedError);
                                    fieldRecord = addValidationMessage(fieldRecord, positionRangeExceedError) ;
                                    wr.isRowValidationFailed = true ;
                                }
                            }

                            
                            if(checkStartDate != null && checkEndDate != null){
                                // if assignment start date is greater than end date
                                if(checkEndDate < checkStartDate){
                                    String errorMessage = string.format(System.Label.Start_Date,new list<string>{System.Label.Start_Date});
                                    errorMessagesList.add(errorMessage);

                                    //endDateFieldWrapper = addValidationMessage(endDateFieldWrapper, errorMessage) ;
                                    startDateFieldWrapper = addValidationMessage(startDateFieldWrapper, errorMessage) ;
                                    wr.isRowValidationFailed = true ;
                                }
                            

                                // if assignment start date is greater than origin hire date or end date is greater than hr termination date
                                if(currentPositionEmployee.Effective_End_Date__c > System.today()){
                                    if(empObj.Original_Hire_Date__c != null || empObj.HR_Termination_Date__c != null) {
                                        Date hireDate;
                                        if(empObj.Original_Hire_Date__c != null){
                                            if(empObj.Rehire_Date__c != null){
                                                if(empObj.Original_Hire_Date__c >empObj.Rehire_Date__c){
                                                    hireDate = empObj.Original_Hire_Date__c;
                                                }else{
                                                    hireDate = empObj.Rehire_Date__c;
                                                }
                                            }else{
                                                hireDate = empObj.Original_Hire_Date__c;
                                            }
                                        }
                                        
                                        if(hireDate == null) {
                                            if(!(checkEndDate <= currentPositionEmployee.Employee__r.HR_Termination_Date__c)) {
                                                String errorMessage = string.format(System.Label.Employee_Assignment_Date_Error, new list<string>{'', currentPositionEmployee.Employee__r.HR_Termination_Date__c.format()});
                                                errorMessagesList.add(errorMessage);

                                                endDateFieldWrapper = addValidationMessage(endDateFieldWrapper, errorMessage) ;
                                                startDateFieldWrapper = addValidationMessage(startDateFieldWrapper, errorMessage) ;
                                                wr.isRowValidationFailed = true ;
                                            }
                                        } 
                                        else if(currentPositionEmployee.Employee__r.HR_Termination_Date__c == null) {
                                            if(!(checkStartDate >= hireDate)) {
                                                String errorMessage = string.format(System.Label.Employee_Assignment_Date_Error, new list<string>{hireDate.format(), ''});
                                                errorMessage = errorMessage.replace('()','');
                                                errorMessagesList.add(errorMessage);

                                                endDateFieldWrapper = addValidationMessage(endDateFieldWrapper, errorMessage) ;
                                                startDateFieldWrapper = addValidationMessage(startDateFieldWrapper, errorMessage) ;
                                                wr.isRowValidationFailed = true ;
                                            }
                                        }
                                        else {
                                            if(!(checkStartDate >= hireDate && checkEndDate <= currentPositionEmployee.Employee__r.HR_Termination_Date__c)) {
                                                System.debug('hireDate :'+hireDate);
                                                String errorMessage = string.format(System.Label.Employee_Assignment_Date_Error, new list<string>{hireDate.format(), currentPositionEmployee.Employee__r.HR_Termination_Date__c.format()});
                                                errorMessagesList.add(errorMessage);

                                                endDateFieldWrapper = addValidationMessage(endDateFieldWrapper, errorMessage) ;
                                                startDateFieldWrapper = addValidationMessage(startDateFieldWrapper, errorMessage) ;
                                                wr.isRowValidationFailed = true ;
                                            }
                                        }
                                    }
                                }
                            }

                        }
                    } // isEditable IF ends    
                               
                }
                

                // check for exact same start date assignemnts in current list of assignemnts
                if(checkStartDate <= checkEndDate && assignmentType == SalesIQGlobalConstants.POSITION_EMPLOYEE_ASSIGNMENT_PRIMARY) {
                    if(allPrimaryAssignmentsByStartDate.containsKey(checkStartDate)) {
                        wr.isRowValidationFailed = true ;
                        String errorMessage;
                        if(moduleName == SalesIQGlobalConstants.EMPLOYEE_UNIVERSE)
                            errorMessage = System.Label.Primary_Assignment_Overlapping_On_Same_Employee ;
                        else
                            errorMessage = System.Label.Date_Overlapping_On_Same_Position ;

                        assignmentTypeFieldWrapper = addValidationMessage(assignmentTypeFieldWrapper, errorMessage) ;
                        errorMessagesList.add(errorMessage);
                    } else {
                        allPrimaryAssignmentsByStartDate.put(checkStartDate, wr);
                    }
                }
            
            
        } // End of object detail wrapper

        // check for mid range overlapping
        List<Date> sortedStartDates = new List<Date>(allPrimaryAssignmentsByStartDate.keySet());
        /*sort all the assignments by start date*/
        sortedStartDates.sort();

        Date previousStartDate, previousEndDate ;
        Date startDate, endDate;
        ObjectDetailWrapper.FieldDetailWrapper assignmentTypeFieldWrapper = null ;
        for(Date sortedDate : sortedStartDates){
            ObjectDetailWrapper wr = allPrimaryAssignmentsByStartDate.get(sortedDate);
            for(ObjectDetailWrapper.FieldDetailWrapper fieldRecord : wr.recordDetails){
                
                if(fieldRecord.fieldApiName == namespace+'Effective_Start_Date__c' && fieldRecord.fieldValue != '' && fieldRecord.fieldValue != null){
                    startDate = Date.valueOf(fieldRecord.fieldValue);
                }

                if(fieldRecord.fieldApiName == namespace+'Effective_End_Date__c' && fieldRecord.fieldValue != '' && fieldRecord.fieldValue != null){
                    endDate = Date.valueOf(fieldRecord.fieldValue);
                }

                if(fieldRecord.fieldApiName == namespace+'Assignment_Type__c') {
                    assignmentTypeFieldWrapper = fieldRecord ;
                }
            }

            if(previousStartDate==null && previousEndDate==null){                           
                previousStartDate = startDate;
                previousEndDate = endDate;                            
            }else{                       
                if(startDate <= previousEndDate){  

                    String errorMessage;
                    if(moduleName == SalesIQGlobalConstants.EMPLOYEE_UNIVERSE)
                        errorMessage = System.Label.Primary_Assignment_Overlapping_On_Same_Employee ;
                    else
                        errorMessage = System.Label.Date_Overlapping_On_Same_Position ;

                    errorMessagesList.add(errorMessage);
                    assignmentTypeFieldWrapper = addValidationMessage(assignmentTypeFieldWrapper, errorMessage) ;
                    wr.isRowValidationFailed = true ;                         
                }else{                           
                    previousStartDate = startDate;
                    previousEndDate = endDate;                            
                }                      
            }
        }

        return new List<String>(errorMessagesList) ;
    }

    private static List<ObjectDetailWrapper> cleanPreviousValidationErrors(List<ObjectDetailWrapper> recordDetails) {
        for(ObjectDetailWrapper wr : recordDetails) {
            wr.isRowValidationFailed = false;
            for(ObjectDetailWrapper.FieldDetailWrapper fieldRecord: wr.recordDetails) {
                fieldRecord.isValidationFailed = false;
                fieldRecord.validationErrorMessage = new Set<String>();
            }
        }

        return recordDetails ;
    } 

    @AuraEnabled
    public static List<String> checkValidations(String recordDetailsJSON, String moduleName){

        try {
            //Map of PositionID to Position Employee
            Map<Id, List<ObjectDetailWrapper>> positionEmployeesWrapperMap = new Map<Id, List<ObjectDetailWrapper>>();
            Set<String> errorMessagesList = new Set<String>();
            
            List<ObjectDetailWrapper> recordDetails = (List<ObjectDetailWrapper>)JSON.deserialize(recordDetailsJSON, List<ObjectDetailWrapper>.class);
            // clear old validations first
            recordDetails = cleanPreviousValidationErrors(recordDetails);


            Boolean valueChangeFlag = checkValueChange(recordDetails);
            if(!valueChangeFlag) {
                errorMessagesList.add(string.format(System.Label.ManageAssignment_No_Change,new list<string>{system.label.ManageAssignment_No_Change}));

                List<String> response = new List<String>(errorMessagesList);
                response.add(JSON.serialize(recordDetails)) ;

                return response;
            }
            

            // ----------- Values has been updated, so check for required and overlapping date on its own validations ---------------- //
            errorMessagesList.addAll(checkNullAndOverlappingValidation(recordDetails, moduleName)) ;
        
            //@todo: May be we can return required and data validations first

            // employeeId used by employee universe and positionId is used by position universe
            Id employeeId, positionId ;

            if(moduleName == SalesIQGlobalConstants.EMPLOYEE_UNIVERSE){
                for(ObjectDetailWrapper wr : recordDetails) {
                    if(positionEmployeesWrapperMap.containsKey(wr.record.Position__c)){
                        positionEmployeesWrapperMap.get(wr.record.position__c).add(wr);
                    } else {
                        positionEmployeesWrapperMap.put(wr.record.position__c, new List<ObjectDetailWrapper>{wr});
                    }

                    employeeId = wr.record.Employee__c ;
                }
            }

            else if(moduleName == SalesIQGlobalConstants.POSITION_UNIVERSE){
                for(ObjectDetailWrapper wr : recordDetails) {
                    if(positionEmployeesWrapperMap.containsKey(wr.record.Employee__c)){
                        positionEmployeesWrapperMap.get(wr.record.Employee__c).add(wr);
                    } else {
                        positionEmployeesWrapperMap.put(wr.record.Employee__c, new List<ObjectDetailWrapper>{wr});
                    }

                    positionId = wr.record.Position__c ;
                }
            }

            for(string pos : positionEmployeesWrapperMap.keyset()) { 
                Map<Date, ObjectDetailWrapper> positionEmployeeDateMap = new Map<Date, ObjectDetailWrapper>();
                boolean isAssignmentAlreadyExist = false;

                for( ObjectDetailWrapper objPE : positionEmployeesWrapperMap.get(pos) ){
                    
                    if(positionEmployeeDateMap.containsKey(objPE.record.Effective_Start_Date__c)){
                        isAssignmentAlreadyExist = true;
                        objPE.isRowValidationFailed = true ;
                        errorMessagesList.add(System.Label.Overlapping_Date_Message);

                        for(ObjectDetailWrapper.FieldDetailWrapper fieldRecord : objPE.recordDetails) {
                            if(fieldRecord.fieldApiName == namespace+'Effective_Start_Date__c' && fieldRecord.fieldValue != '' && fieldRecord.fieldValue != null){
                                fieldRecord = addValidationMessage(fieldRecord, System.Label.Overlapping_Date_Message) ;
                            }
                        }
                    }
                    else {
                        if(objPE.record.Effective_Start_Date__c <= objPE.record.Effective_End_Date__c)
                            positionEmployeeDateMap.put(objPE.record.Effective_Start_Date__c, objPE);
                    }
                }

                // exact start date matching is not found, so validate for overlapping dates on same position  
                if(!isAssignmentAlreadyExist)
                {
                    List<Date> allUniqueStartDates = new List<Date>(positionEmployeeDateMap.keySet()) ;
                    allUniqueStartDates.sort() ;
                    
                    Date startDate;
                    Date endDate;
                            
                    for(Date sortedDate : allUniqueStartDates){ 
                        ObjectDetailWrapper objPE = positionEmployeeDateMap.get(sortedDate) ;
                        Position_Employee__c wr = objPE.record;  
                        
                        if(startDate==null && endDate==null){                           
                            startDate = wr.Effective_start_Date__c;
                            endDate = wr.Effective_End_Date__c;                            
                        }
                        else{                       
                            if(wr.Effective_Start_Date__c <= endDate){   
                                objPE.isRowValidationFailed = true ;
                                errorMessagesList.add(System.Label.Overlapping_Date_Message);

                                for(ObjectDetailWrapper.FieldDetailWrapper fieldRecord : objPE.recordDetails) {
                                    if(fieldRecord.fieldApiName == namespace+'Effective_Start_Date__c' && fieldRecord.fieldValue != '' && fieldRecord.fieldValue != null){
                                        fieldRecord = addValidationMessage(fieldRecord, System.Label.Overlapping_Date_Message) ;
                                    }
                                }                           
                            }                           
                            else{                           
                                startDate = wr.Effective_start_Date__c;
                                endDate = wr.Effective_End_Date__c;                            
                            }                       
                        }
                    }
                }
            }
                
            if(SecurityUtil.checkRead(Position_Employee__c.SObjectType, new List<String>{'Assignment_type__c', 'Position__c', 'Employee__c', 'Effective_start_date__c', 'Effective_end_date__c'}, false) && 
                SecurityUtil.checkRead(Employee__c.SObjectType, new List<String>{'Name'}, false) && SecurityUtil.checkRead(Position__c.SObjectType, new List<String>{'Name'}, false) ) {

                List<Position_Employee__c> existingPrimaryPositionEmployees;
                if(moduleName == SalesIQGlobalConstants.EMPLOYEE_UNIVERSE){
                    existingPrimaryPositionEmployees = [select Assignment_type__c, Position__c, Employee__r.Name, Employee__c, Position__r.Name, Effective_start_date__c,Effective_end_date__c 
                                                from Position_Employee__c where Employee__c != :employeeId AND Position__c IN : positionEmployeesWrapperMap.keyset() 
                                                AND Employee__c != null AND Position__c != null AND Assignment_type__c =: SalesIQGlobalConstants.POSITION_EMPLOYEE_ASSIGNMENT_PRIMARY];
                }
                else {
                    existingPrimaryPositionEmployees = [select Assignment_type__c, Position__c, Employee__r.Name, Employee__c, Position__r.Name, Effective_start_date__c,
                                                Effective_end_date__c from Position_Employee__c where Employee__c IN :positionEmployeesWrapperMap.keyset() AND position__c != :positionId 
                                                AND Employee__c != null AND Position__c != null AND Assignment_type__c =: SalesIQGlobalConstants.POSITION_EMPLOYEE_ASSIGNMENT_PRIMARY];
                }

                // fetch existing assignment for "same positions and different employee" or "same employees and different position"
                String alreadyAssignedError ;
                if(moduleName == SalesIQGlobalConstants.EMPLOYEE_UNIVERSE) {
                    alreadyAssignedError = System.Label.Already_Assign_Position;
                } else {
                    alreadyAssignedError = System.Label.Already_Assign_Employee;
                }

                for(Position_Employee__c pEmp: existingPrimaryPositionEmployees){
                    List<ObjectDetailWrapper> currentWrapperList;
                    if(moduleName == SalesIQGlobalConstants.EMPLOYEE_UNIVERSE)
                        currentWrapperList = positionEmployeesWrapperMap.get(pEmp.Position__c) ;
                    else
                        currentWrapperList = positionEmployeesWrapperMap.get(pEmp.Employee__c) ;

                    for( ObjectDetailWrapper objPEWrapper : currentWrapperList){
                        Position_Employee__c objPE = objPEWrapper.record ;
                        if(objPE.assignment_type__c == SalesIQGlobalConstants.POSITION_EMPLOYEE_ASSIGNMENT_PRIMARY){
                            Date oldStartDate = objPE.effective_start_date__c;
                            Date oldEndDate = objPE.effective_end_date__c;
                                
                            Date newStartDate = pEmp.effective_start_date__c;
                            Date newEndDate = pEmp.effective_end_date__c;
                                 
                            if(!((oldStartDate < newStartDate && oldEndDate < newStartDate) || (oldStartDate > newEndDate && oldEndDate > newEndDate))){
                                objPEWrapper.isRowValidationFailed = true;
                                errorMessagesList.add(alreadyAssignedError);

                                for(ObjectDetailWrapper.FieldDetailWrapper fieldRecord : objPEWrapper.recordDetails) {
                                    if(fieldRecord.fieldApiName == namespace+'Effective_Start_Date__c' && fieldRecord.fieldValue != '' && fieldRecord.fieldValue != null){
                                        fieldRecord = addValidationMessage(fieldRecord, alreadyAssignedError) ;
                                    }

                                    if(fieldRecord.fieldApiName == namespace+'Effective_End_Date__c' && fieldRecord.fieldValue != '' && fieldRecord.fieldValue != null){
                                        fieldRecord = addValidationMessage(fieldRecord, alreadyAssignedError) ;
                                    }
                                }
                                break ;  
                            }             
                        }
                    }
                }
            }

            IManageAssignment v;
            Boolean externalClassPresent = false;
            list<Package_Extension__mdt> pkgExtList = SalesIQUtility.getPackageExtensionsByLabels(new set<string>{System.Label.Manage_Assignment_Validation_External_Class});
            string className = '';
            if(pkgExtList != null && pkgExtList.size() > 0){
                className = pkgExtList[0].ClassName__c;
            }
            if(className != ''){
                v = SalesIQUtility.getManageAssignmentInterfaceInstance(className);
                ValidationResponse valResp = v.checkValidations(recordDetailsJSON, moduleName);
                if(valResp != null){
                    externalClassPresent = true;
                    Boolean isError = false;
                    if(errorMessagesList.size() > 0)
                        isError = true;

                    if(valResp.responseType == 'Error' || valResp.responseType == 'Warning')
                    {
                        for(string errorMsg : valResp.responseMessage)
                        {
                            errorMessagesList.add(errorMsg);
                        }
                    }

                    if(isError)
                        errorMessagesList.add('Error');
                    else if(valResp.responseType == null || valResp.responseType == '')
                        errorMessagesList.add('Success');
                    else
                        errorMessagesList.add(valResp.responseType);
                }
            }     

            if(!externalClassPresent && errorMessagesList.size() == 0)
                errorMessagesList.add('Success');
            else if(!externalClassPresent && errorMessagesList.size() > 0)
                errorMessagesList.add('Error');

            List<String> response = new List<String>(errorMessagesList);
            response.add(JSON.serialize(recordDetails)) ;

            return response;
        } 
        catch (TypeException e) {
            String message = e.getMessage();
            AuraHandledException ex = new AuraHandledException(message);
            ex.setMessage(message);
            throw ex;
        }
        catch (Exception e) {
            String message = e.getTypeName() + ': ' + e.getMessage() + '\n\n' + e.getStackTraceString() ;
            AuraHandledException ex = new AuraHandledException(message);
            ex.setMessage(message);
            throw ex;
        }
    }


    @AuraEnabled
    public static List<String> saveAssignments(String recordDetailsJSON, String moduleName,String profileString) {
        
        Savepoint s = Database.setSavepoint() ;
        try{

           list<Object> profileMap;
           //list<Object> profileMap = (list<Object>)JSON.deserializeUntyped(profileString);
            try{

                map<String, Object> profile = (map<String, Object>)JSON.deserializeUntyped(profileString);
                profileMap = new list<Object>();
                profileMap.add('{');
                for(String key : profile.keySet()){
                    System.debug('key :'+key);
                    System.debug(profile.get(key));
                    profileMap.add(key + '=' + profile.get(key) +'');

                }
                profileMap.add('}');
            }catch(System.TypeException e){
                profileMap = (list<Object>)JSON.deserializeUntyped(profileString);
            }
            
            System.debug('profileMap :: '+profileMap);
            
            List<ObjectDetailWrapper> recordDetails = (List<ObjectDetailWrapper>)JSON.deserialize(recordDetailsJSON, List<ObjectDetailWrapper>.class);
            Map<Position__c, List<ObjectDetailWrapper>> positionWithAssignmentDetailsMap = new Map<Position__c, List<ObjectDetailWrapper>>();

            for(ObjectDetailWrapper positionEmployeeWrapper : recordDetails) {
                Position__c position = new Position__c(Id=positionEmployeeWrapper.record.Position__c, Team_Instance__c=positionEmployeeWrapper.record.Position__r.Team_Instance__c);

                // include the position employee only when there is any change in the values
                Boolean validationPass = checkValueChange(new List<ObjectDetailWrapper>{positionEmployeeWrapper});
                if(validationPass) {
                    if(positionWithAssignmentDetailsMap.containsKey(position)) {
                        positionWithAssignmentDetailsMap.get(position).add(positionEmployeeWrapper);
                    }  else {
                        positionWithAssignmentDetailsMap.put(position, new List<ObjectDetailWrapper>{positionEmployeeWrapper});
                    }
                }
            }
            List<String> positionEmployeeEditableFields = new List<String>();

            Map<Id, Change_request__c> changeRequestPerPositionMap = new Map<Id, Change_Request__c>();
            Map<Id, List<CR_Employee_Assignment__c>> crEmployeeAssignmentPerPositionMap = new Map<Id, List<CR_Employee_Assignment__c>>();
            List<Position_Employee__c> positionEmployeesToUpsert = new List<Position_Employee__c>();
            Employee__c employeeToUpdate = new Employee__c(Id = recordDetails[0].record.Employee__c) ;
            String changeRequestStatus ;

            // Loop on each position and generate CR for only that Position realted assignments
            for(Position__c position : positionWithAssignmentDetailsMap.keySet()) {
                
                List<User> approvalUserList = new List<User>();
                List<String> approverResponseList = new List<String>();

                Change_request__c empAssignmentCR = SalesIQUtility.createChangeRequestRoster(SalesIQGlobalConstants.REQUEST_STATUS_PENDING, system.today(), SalesIQGlobalConstants.EMPLOYEE_ASSIGNMENT, position.Team_Instance__c, SalesIQGlobalConstants.EMPLOYEE_ASSIGNMENT, SalesIQGlobalConstants.EMPLOYEE_ASSIGNMENT,position.Id);
                // @todo, check if CR's Is_Auto_Approved is not getting checked
                SalesIQUtility.createApprovals(empAssignmentCR, approvalUserList, approverResponseList,profileMap);
                map<String,String> reasonCodeMap = new map<String,String>();
                List<Position_Employee__c> positionEmployeesToUpsertIntermediate = new List<Position_Employee__c>();
                for(ObjectDetailWrapper positionEmployeeWrapper : positionWithAssignmentDetailsMap.get(position)) {
                    Position_Employee__c positionEmployee = positionEmployeeWrapper.record ;
                    positionEmployee.Status__c = SalesIQGlobalConstants.REQUEST_STATUS_PENDING ;

                    if(positionEmployee.Id == null)
                        positionEmployee.IsNew__c = true ;

                    for(ObjectDetailWrapper.FieldDetailWrapper positionEmpFieldWrapper : positionEmployeeWrapper.recordDetails) {
                        if(positionEmpFieldWrapper.isEditable) {
                            // add the editable field into a list
                            positionEmployeeEditableFields.add(positionEmpFieldWrapper.fieldApiName);
                        }
                    }
                    reasonCodeMap.put(positionEmployee.Position__c, positionEmployee.Reason_Code__c);
                    positionEmployeesToUpsertIntermediate.add(positionEmployee);
                }

                changeRequestStatus = empAssignmentCR.Status__c ;

                empAssignmentCR.Status__c = SalesIQGlobalConstants.REQUEST_STATUS_PENDING;  
                empAssignmentCR.source_position__c = position.Id;
                empAssignmentCR.destination_position__c = position.Id;
                empAssignmentCR.Reason__c = reasonCodeMap.get(empAssignmentCR.Source_Position__c);

                if(TotalApproval__c.getValues('Approvals') != null && TotalApproval__c.getValues('Approvals').No_Of_Approval__c != null)                             
                    // @todo, check if CR approver fields are getting updated
                    AlignmentUtility.AssignApproval(empAssignmentCR, approvalUserList, integer.valueOf(TotalApproval__c.getValues('Approvals').No_Of_Approval__c));
                 
                
                List<CR_Employee_Assignment__c> crEmployeeAssgignmentList = SalesIQUtility.createCRempAssgn(empAssignmentCR, positionEmployeesToUpsertIntermediate);

                changeRequestPerPositionMap.put(position.Id, empAssignmentCR);
                crEmployeeAssignmentPerPositionMap.put(position.Id, crEmployeeAssgignmentList);

                positionEmployeesToUpsert.addAll(positionEmployeesToUpsertIntermediate);
            }

            if((SecurityUtil.checkInsert(Position_Employee__c.SObjectType, positionEmployeeEditableFields, true)) && 
                (SecurityUtil.checkUpdate(Position_Employee__c.SObjectType, positionEmployeeEditableFields, true))) {
                upsert positionEmployeesToUpsert;
            }

            //if(SecurityUtil.checkUpdate(Employee__c.SObjectType, EMPLOYEE_UPDATE_FIELD, false)) {   
                employeeToUpdate.change_status__c = changeRequestStatus ;
                update employeeToUpdate ;
            //}

            //
            //if(SecurityUtil.checkInsert(Change_Request__c.SObjectType, CHANGE_REQUEST_INSERT_FIELD, false)) {
                insert changeRequestPerPositionMap.values();                              
            //}

            // populate CR link on CR Employee
            List<CR_Employee_Assignment__c> tobeInsertedCrEmployeeAssignments = new List<CR_Employee_Assignment__c>();
            for(Id positionId : changeRequestPerPositionMap.keySet()) {
                for(CR_Employee_Assignment__c employeeAssgCR : crEmployeeAssignmentPerPositionMap.get(positionId)) {
                    employeeAssgCR.Change_Request_ID__c = changeRequestPerPositionMap.get(positionId).Id ;
                    tobeInsertedCrEmployeeAssignments.add(employeeAssgCR);
                }
            }

            //if(SecurityUtil.checkInsert(CR_Employee_Assignment__c.SObjectType, CR_EMPLOYEE_ASSIGNMENT_INSERT_FIELD, false)) {
                insert tobeInsertedCrEmployeeAssignments;                               
            //}

            List<Change_Request__c> queryNewChangeRequests = [select Name from Change_Request__c where Id in : changeRequestPerPositionMap.values()];
            List<String> changeRequestNames = new List<String>() ;
            List<Id> changeRequestIds = new List<Id>() ;
            String changeRequestIdsString = '';
            Map<String,String> changeRequestMap = new Map<String,String>();
            for(Change_Request__c changeReq : queryNewChangeRequests) 
            {
                changeRequestMap.put(changeReq.Name, +'#/sObject/' + changeReq.Id + '/view');
                changeRequestIds.add(changeReq.Id);
            }
            SalesIQUtility.submitForApproval(changeRequestIds, changeRequestStatus);
            return new List<String>{'True', JSON.serialize(changeRequestMap)};

        } 
        catch(Exception e) 
        {
            Database.rollback(s);
            //return new List<String>{e.getMessage(), e.getStackTraceString()};
            if(e.getMessage().indexOf('FIELD_CUSTOM_VALIDATION_EXCEPTION') != -1){
                String message = e.getMessage().split(',')[1];
                return new List<String>{message};
            }else{
                return new List<String>{e.getMessage(), e.getStackTraceString()};
            }
            return new list<String>{};
        }
    }

    @AuraEnabled
    public static List<String> getPendingChangeRequests(String recordId,String moduleName)
    {
        
            List<String> pendingCR = new List<String>();
            List<Change_Request__c> crList;
             list<string> CR_EMPLOYEE_ASSIGNMENT_READ_FIELD = new list<string>{'id','Change_Request_ID__c','Employee_ID__c','Position_ID__c'};
            List<String> CHANGE_REQUEST_READ_FIELD = new List<String>{'Name','Status__c'};
            if(SecurityUtil.checkRead(CR_Employee_Assignment__c.SObjectType, CR_EMPLOYEE_ASSIGNMENT_READ_FIELD, false) && SecurityUtil.checkRead(Change_Request__c.SObjectType, CHANGE_REQUEST_READ_FIELD, false))
            {
                if(moduleName == SalesIQGlobalConstants.EMPLOYEE_UNIVERSE)
                {
                    crList = [Select Name from Change_Request__c where Id in (Select Change_Request_ID__c from CR_Employee_Assignment__c where Employee_ID__c =: recordId and Change_Request_ID__r.Status__c =: SalesIQGlobalConstants.REQUEST_STATUS_PENDING)];
                }
                else if(moduleName == SalesIQGlobalConstants.POSITION_UNIVERSE)
                {
                    crList = [Select Name from Change_Request__c where Id in (Select Change_Request_ID__c from CR_Employee_Assignment__c where Position_ID__c=: recordId and Change_Request_ID__r.Status__c =: SalesIQGlobalConstants.REQUEST_STATUS_PENDING)];
                }
                    
            }    

            for(Change_Request__c cr : crList)
            {
                pendingCR.add(cr.Name);
            }

            return pendingCR;
    }
    
    @AuraEnabled
    public static string getExternalComponentDetail(){

        if(Alignment_Global_Settings__c.getValues('InvokeExternalComponent') != null){
            return Alignment_Global_Settings__c.getValues('InvokeExternalComponent').Tree_Hierarchy_Sort_Field__c;
        }else
            return '';
    }

    @AuraEnabled
    public static void logException(String message,String module) 
    {
        if(message.length() > 2000)
            message = message.substring(0,2000);
        SalesIQLogger.logErrorMessage(message, module);
    }
    
    
    @AuraEnabled
    public static boolean isBusinessRuleRunning(string teamInstanceID){
       boolean isLocked = false;
       list<Team_Instance__c> lstTeamInst = [select id,Scenario__r.Is_Locked__c from Team_Instance__c where id =: teamInstanceID];
       for(Team_Instance__c teamInt : lstTeamInst){       	   		
       		isLocked = teamInt.Scenario__r.Is_Locked__c;
       }
       return isLocked;
    }

    @AuraEnabled
    public static String getDateRuleSetting(){
        if(Position_Global_Settings__c.getInstance('default_15_16_Rule') != null)
            return String.valueOf(Position_Global_Settings__c.getInstance('default_15_16_Rule').Child_Effective_Dates_within_Parent__c);        
        else
            return 'false';
    } 

    @AuraEnabled
    public static map<String,String> getAssignmentColors(){
        map<String,String> displayColors = new map<String,String>();
        displayColors.put('PrimaryAssignment','rgb(4, 132, 75)');
        displayColors.put('SecondaryAssignment','rgb(255, 154, 60)');
        displayColors.put('Unassigned','rgb( 217, 100, 94)');
        
        if(DiplayColorCriteria__c.getValues('PrimaryAssignment') != null){
            displayColors.put('PrimaryAssignment',DiplayColorCriteria__c.getValues('PrimaryAssignment').Color__c);
        }if(DiplayColorCriteria__c.getValues('SecondaryAssignment') != null){
            displayColors.put('SecondaryAssignment',DiplayColorCriteria__c.getValues('SecondaryAssignment').Color__c);
        }if(DiplayColorCriteria__c.getValues('Unassigned') != null){
            displayColors.put('Unassigned',DiplayColorCriteria__c.getValues('Unassigned').Color__c);
        }

        return displayColors;
        //return JSON.serialize(displayColors);
    }
}